using Microsoft.VisualBasic;
using System;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HiNet_Test
{
    public partial class FrmMain : Form
    {

        //M~p
        static public Boolean gbooStopFlag;     
        
        public FrmMain()
        {
            InitializeComponent();
        }

        //Form Load
        private void FrmMain_Load(object sender, EventArgs e)
        {
            short sts;
            short shoIO = 0;
            
            //HINETyz
            sts = HI32NT.initial(shoIO);
            if (sts != 0)
            {
                ErrMsg(sts);
            }
         }

        //OPEN[BSC]
        private void btnOpen_Click(object sender, EventArgs e)
        {
            short sts;

            //OPEN[BSC]
            short shoCH =0;
            string strID1 = "";
            string strID2 = "";
            short shoMode = 0x22;
            short shoProt = 1;
            short shoBPS  = 5;

            sts = HI32NT.bscopen(shoCH, ref strID1, ref strID2, shoMode, shoProt, shoBPS);
            if (sts != 0)
            {
                ErrMsg(sts);
            }else{
                lblOpen.Text = "y OPEN z";
                lblOpen.BackColor = Color.Yellow;
                btnOpen.Enabled = false;
                btnClose.Enabled = true;
                btnSend.Enabled = true;
                btnRecv.Enabled = true;
                txtSend.Enabled = true;
                txtRecv1.Enabled = true;
                txtRecv2.Enabled = true;
                txtRecv3.Enabled = true;
                txtRecv4.Enabled = true;
                txtRecv5.Enabled = true;
                lblSendOK.Text = "";
                lblRecvOK.Text = "";
            }
        }

        //Close
        private void btnClose_Click(object sender, EventArgs e)
        {
            short sts;

            //Close
            short CH = 0;
            
            sts = HI32NT.chclose(CH);
            if (sts != 0)
            {
                ErrMsg(sts);
            }else {
                lblOpen.Text = "y CLOSE z";
                lblOpen.BackColor = Color.White;
                btnOpen.Enabled = true;
                btnClose.Enabled = false;
                btnSend.Enabled = false;
                btnRecv.Enabled = false;
                txtSend.Enabled = false;
                txtRecv1.Enabled = false;
                txtRecv2.Enabled = false;
                txtRecv3.Enabled = false;
                txtRecv4.Enabled = false;
                txtRecv5.Enabled = false;
                lblSendOK.Text = "";
                lblRecvOK.Text = "";
            }
        }


        //M{^
        private void btnSend_Click(object sender, EventArgs e)
        {
            short sts;
            short shoCH=0;
            string strSendData="";
            byte[] SD = new byte[50];
            short shoLength;
            short shoMode=0;

            //Mf[^(j
            strSendData = txtSend.Text;

            if (strSendData == "") 
            {
                MessageBox.Show("Mf[^ɓ͂Ă");
                return;
            }
            
            btnSend.Enabled = false;
            btnRecv.Enabled = false;
            lblSendOK.Text = "";
                                                
            //Mf[^
            shoLength = (short)strSendData.Length;
            
            //Mf[^@STRING  Bytez֕ϊ
            for (int i = 0; i < shoLength; i++)
            {
                SD[i] =(byte)Strings.Asc(Strings.Mid(strSendData, i+1, 1));
            }
           
            //f[^M
            sts = HI32NT.bscsend(shoCH,ref SD[0], shoLength, shoMode);
            if (sts != 0)
            {
                ErrMsg(sts);
            } else {

                //SendCheck STS=1̊Ԃ̓obt@Ƀf[^
                sts = 1;
                while (sts == 1)
                {
                    sts = HI32NT.sendck(0);
                }
                if (sts != 0)
                {
                    ErrMsg(sts);
                } else {
                    lblSendOK.Text = "yMz";
                }
            }
            btnSend.Enabled = true;
            btnRecv.Enabled = true;
        }

        //M{^
        private void btnRecv_Click(object sender, EventArgs e)
        {
            short sts = 0;
            byte [] RD = new byte[1024];
            string strRcvData = "";
            int intRcvLen = 0;

            btnSend.Enabled = false;
            btnRecv.Enabled = false;
            btnStop.Enabled = true;

            txtRecv1.Text = "";
            txtRecv2.Text = "";
            txtRecv3.Text = "";
            txtRecv4.Text = "";
            txtRecv5.Text = "";

            gbooStopFlag = false;
            lblRecvOK.Text = "yMz";
            do {
                Application.DoEvents();
                            
                do {
                    Application.DoEvents();

                    //~tOꍇ͑ɔ
                    if (gbooStopFlag == true){
                        btnSend.Enabled = true;
                        btnRecv.Enabled = true;
                        btnStop.Enabled = false;
                        lblRecvOK.Text = "";
                        return;
                    }

                    //M
                    sts = HI32NT.hrecv(0, ref RD[0]);
                    if (sts != 0){

                        //M̃G[`FbN
                        if ((sts & 0x8000) == 0x8000){
                            ErrMsg(sts);
                            lblRecvOK.Text = "yMErrorz";
                            return;
                        }

                        //Mf[^̎擾
                        intRcvLen = sts & 0x1FFF;

                        //؂蕶̎擾
                        switch ((sts / 0x2000) & 3) {
                            case 0x0:
                                sts = 1;
                                break;

                            case 0x1: 
                                sts = 2;
                                break;
                            
                            case 0x2:
                                sts = 3;
                                break;

                            case 0x3:
                                sts = 1;
                                break;
                        }
                    }
                }
                while (sts == 0);
                
                //Mf[^A
                switch (sts){

                    //ETX
                    case 1:
                        strRcvData = "";
                        for (int i = 0; i < intRcvLen; i++){
                            strRcvData = strRcvData + Strings.Chr(RD[i]);
                        }
                        strRcvData = strRcvData + "[ETX]";
                        RcvDataOn(strRcvData);
                        break;

                    //ETB
                    case 2:
                        strRcvData = "";
                        for (int i = 0; i < intRcvLen; i++){
                            strRcvData = strRcvData + Strings.Chr(RD[i]);
                        }
                        strRcvData = strRcvData + "[ETB]";
                        RcvDataOn(strRcvData);
                        break;

                    //EOT
                    case 3:
                        strRcvData = "[EOT]";
                        RcvDataOn(strRcvData);
                        break;
                }
            
            }
            while(sts!=3);
            lblRecvOK.Text = "yMz";
            btnSend.Enabled = true;
            btnRecv.Enabled = true;
            btnStop.Enabled = false;
                        
        }

        //M̒~
        private void btnStop_Click(object sender, EventArgs e)
        {
            gbooStopFlag = true;
        }


        //PG̏I
        private void btnEnd_Click(object sender, EventArgs e)
        {
            short sts;

            //I[vȂؒfĂ
            if (lblOpen.Text == "y OPEN z")
            {
                sts = HI32NT.chclose(0);
            }

            //PG̏I
            Application.Exit();
        }
        
        //===================================================================================
        //Mf[^\@JĂeLXg{bNXĕ\܂
        //===================================================================================
        private void RcvDataOn(string Data)
        {
            if (txtRecv1.Text == "")
            {
                txtRecv1.Text = Data;
                return;
            }
            else if (txtRecv2.Text=="")
            {
                txtRecv2.Text = Data;
                return;
            }
            else if (txtRecv3.Text == "")
            {
                txtRecv3.Text = Data;
                return;
            }
            else if (txtRecv4.Text == "")
            {
                txtRecv4.Text = Data;
                return;
            }
            else if (txtRecv5.Text == "")
            {
                txtRecv5.Text = Data;
                return;
            }
        }

        //===================================================================================
        //G[bZ[W֐
        //===================================================================================
        private void ErrMsg(int errno)
        {
            string mess="";
            
            errno = errno & 0x7fff;
            switch (errno)
            {
                case 2:
                    mess = "Mobt@I[o[t[܂";
                    break;

                case 3:
                    mess = "fqĂȂA܂ُ͈ł";
                    break;
                
                case 4:
                    mess = "db͊ɌqĂ܂";
                    break;
                
                case 5: 
                    mess = "͊ɃI[vĂ܂";
                    break;
                
                case 6:
                    mess = "I[vĂ܂";
                    break;
                
                case 9: 
                    mess = "I/OAhX̐ݒ肪Ă܂";
                    break;

                case 0x11: 
                    mess = "MDLEEEOTM܂";
                    break;

                case 0x12: 
                    mess = "Mőǂł";
                    break;
                
                case 0x13:
                    mess = "MNAKM܂";
                    break;
                
                case 0x14: 
                    mess = "MDLEEEOTM܂";
                    break;
                
                case 0x15: 
                    mess = "Mőǂł";
                    break;
                
                case 0x16: 
                    mess = "MNAKM܂";
                    break;
                
                case 0x17: 
                    mess = "MŒf󂯎܂";
                    break;
                
                case 0x18: 
                    mess = "WACK̃gCAEg";
                    break;
                
                case 0x19: 
                    mess = "ʐM^CAEg";
                    break;
                
                case 0x1A: 
                    mess = "Mł̃n[hG[";
                    break;
                
                case 0x1B: 
                    mess = "RVI(M])󂯎܂";
                    break;
                
                case 0x1C: 
                    mess = "MEOTM܂";
                    break;
                
                case 0x21: 
                    mess = "MDLEEEOTM܂";
                    break;
                
                case 0x22: 
                    mess = "MŃobt@zf[^M܂";
                    break;
                
                case 0x23: 
                    mess = "MŎMĎ^CAEgɂȂ܂";
                    break;
                
                case 0x31:
                    mess = "_C̃R}hĂ܂";
                    break;
                
                case 0x35:
                    mess = "db@ċ֎~ɂȂĂ܂";
                    break;
                
                case 0x36:
                    mess = "ǂbł";
                    break;
                
                case 0x38:
                    mess = "dbĂ܂";
                    break;

                case 0x39: 
                    mess = "dbڑAT[g[AĂ܂";
                    break;

                case 0x3A: 
                    mess = "dbڑAǂł܂";
                    break;
                
                case 0x3B:
                    mess = "_CIAڑ܂";
                    break;
            }
            //G[bZ[W̕\
            if (mess != "")
            {
                MessageBox.Show(mess);
            }
        }


         
    }
        
    //HINET DLL̒`
    class HI32NT
    {
        [DllImport("HI-NET32USB.dll")]
        public static extern short initial(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short bsizeset(short CH, short Bsiz);

        [DllImport("HI-NET32USB.dll")]
        public static extern short padset(short CH, short Lpad, short Lpadl,short Tpad, short Tpadl);

        [DllImport("HI-NET32USB.dll")]
        public static extern short syncset(short CH, short Synccd, short Synccdl);

        [DllImport("HI-NET32USB.dll")]
        public static extern short timeset(short CH, short Tm1, short Tm2, short Tm3, short Tm4, short Tm5);
        
        [DllImport("HI-NET32USB.dll")]
        public static extern short bscopen(short CH,ref string ID1,ref string ID2,short MODE, short PROT, short BPS);

        [DllImport("HI-NET32USB.dll")]
        public static extern short nec2open(short CH,  short PROT, short BPS, string ISAUA, short MODE);

        [DllImport("HI-NET32USB.dll")]
        public static extern short nec3open(short CH, short PROT, short BPS, short sa, ref int OUA, ref int IUA, short MODE);

        [DllImport("HI-NET32USB.dll")]
        public static extern short chclose(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short telon(short CH, ref string DIAL, short TM);

        [DllImport("HI-NET32USB.dll")]
        public static extern short mtelon(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short teloff(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short rdtck(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short hrecv(short CH, ref byte DAT);

        [DllImport("HI-NET32USB.dll")]
        public static extern short hrecvx(short CH, ref int DAT);

        [DllImport("HI-NET32USB.dll")]
        public static extern short nec2send(short CH, ref byte DAT, short LENG, short OSA, short OUA, short Em);

        [DllImport("HI-NET32USB.dll")]
        public static extern short nec3send(short CH, ref byte DAT, short LENG, short OUA, short Em);

        [DllImport("HI-NET32USB.dll")]
        public static extern short bscsend( short CH, ref byte DAT, short LENG, short Em);

        [DllImport("HI-NET32USB.dll")]
        public static extern short sendck(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short verget(short CH, ref string Ver);

        [DllImport("HI-NET32USB.dll")]
        public static extern short retryset(short CH,short R1, short R2, short R3, short R4,short R5);

        [DllImport("HI-NET32USB.dll")]
        public static extern short rbfclr(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short sbfclr(short CH);

        [DllImport("HI-NET32USB.dll")]
        public static extern short pollon(short CH, short IUA);

        [DllImport("HI-NET32USB.dll")]
        public static extern short polloff(short CH, short IUA);

        [DllImport("HI-NET32USB.dll")]
        public static extern short pollstat(short CH, short IUA);

        [DllImport("HI-NET32USB.dll")]
        public static extern short ridget(short CH, ref string ID);
  
    }

}